"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _set = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set"));

var _values = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/values"));

var _foundation = _interopRequireDefault(require("../base/foundation"));

class CollapseFoundation extends _foundation.default {
  constructor(adapter) {
    super((0, _assign.default)({}, adapter));
  }

  initActiveKey() {
    const {
      defaultActiveKey,
      activeKey,
      accordion
    } = this.getProps();
    let activeKeyList = activeKey ? activeKey : defaultActiveKey;

    if (accordion) {
      activeKeyList = (0, _isArray.default)(activeKeyList) ? activeKeyList[0] : activeKeyList;
    }

    if (activeKeyList && activeKeyList.length) {
      activeKeyList = (0, _isArray.default)(activeKeyList) ? activeKeyList : [activeKeyList];
      return activeKeyList;
    }

    return []; // this._adapter.initActiveSet(activeKeyList);
  }

  handleChange(newKey, e) {
    const {
      activeKey,
      accordion
    } = this.getProps();
    const {
      activeSet
    } = this.getStates();
    let newSet = new _set.default(activeSet);

    if (newSet.has(newKey)) {
      newSet.delete(newKey);
    } else {
      if (accordion) {
        newSet = new _set.default([newKey]);
      } else {
        newSet.add(newKey);
      }
    }

    this._adapter.handleChange([...(0, _values.default)(newSet).call(newSet)], e);

    if (typeof activeKey === 'undefined') {
      this._adapter.addActiveKey(newSet);
    }
  }

}

exports.default = CollapseFoundation;