"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _globalThis2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/global-this"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _warning = _interopRequireDefault(require("./warning"));

const touchEventPolyfill = (touch, touchEvent) => {
  /* Touch is the first point of multi-touch. In order to minimize the change of slider code to support touch,
  some methods that will be used on touchEvent are mounted on the multi-touch Touch object.*/
  // polyfill for firefox
  if (!_globalThis2.default.Touch || !(touch instanceof Touch)) {
    return touch;
  }

  const keysNeedPolyfill = ['stopPropagation', 'preventDefault'];
  (0, _forEach.default)(keysNeedPolyfill).call(keysNeedPolyfill, key => {
    let value = touchEvent[key];

    if (value) {
      if (typeof value === 'function') {
        // bind 'this' for function of touchEvent running in Touch Point Object
        value = function () {
          return touchEvent[key](...arguments);
        };
      }

      if (touch[key]) {
        (0, _warning.default)(true, "\"The key ".concat(key, "\" exist in Touch."));
      } else {
        touch[key] = value;
      }
    }
  });
  return touch;
};

var _default = touchEventPolyfill;
exports.default = _default;